--- nginx-1.1.4/src/http/ngx_http_variables.c	2011-05-30 05:36:17.000000000 -0700
+++ nginx-1.1.4-patched/src/http/ngx_http_variables.c	2011-09-29 11:57:07.000000000 -0700
@@ -648,7 +648,14 @@
 
     a = (ngx_array_t *) ((char *) r + data);
 
-    n = a->nelts;
+    h = a->elts;
+    n = 0;
+
+    for (i = 0; i < a->nelts; i++) {
+        if (h[i]->hash) {
+            n++;
+        }
+    }
 
     if (n == 0) {
         v->not_found = 1;
@@ -659,19 +666,12 @@
     v->no_cacheable = 0;
     v->not_found = 0;
 
-    h = a->elts;
-
-    if (n == 1) {
-        v->len = (*h)->value.len;
-        v->data = (*h)->value.data;
-
-        return NGX_OK;
-    }
-
     len = - (ssize_t) (sizeof("; ") - 1);
 
-    for (i = 0; i < n; i++) {
-        len += h[i]->value.len + sizeof("; ") - 1;
+    for (i = 0; i < a->nelts; i++) {
+        if (h[i]->hash) {
+            len += h[i]->value.len + sizeof("; ") - 1;
+        }
     }
 
     p = ngx_pnalloc(r->pool, len);
@@ -683,6 +683,10 @@
     v->data = p;
 
     for (i = 0; /* void */ ; i++) {
+        if (!h[i]->hash) {
+            continue;
+        }
+
         p = ngx_copy(p, h[i]->value.data, h[i]->value.len);
 
         if (i == n - 1) {